#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include <qmainwindow.h>
#include <qpushbutton.h>
#include <qdirectpainter_qws.h>
#include <qimage.h>
#include <qtimer.h>
#include <qpe/applnk.h>
#include <qlabel.h>

extern "C" {
#include "driver.h"
#include "drivers/common/unixdsp.h"
}

#define JOY_A   1
#define JOY_B   2
#define JOY_SELECT      4
#define JOY_START       8
#define JOY_UP  0x10
#define JOY_DOWN        0x20
#define JOY_LEFT        0x40
#define JOY_RIGHT       0x80

class QpeFceu : public QMainWindow
{
	Q_OBJECT
	
public:
	QpeFceu( QWidget *parent = 0, const char *name = 0, WFlags f = 0 );
	~QpeFceu();
	void init(void);
	
protected:
	virtual void keyPressEvent(QKeyEvent*);
	virtual void keyReleaseEvent(QKeyEvent*);
	virtual void closeEvent(QCloseEvent*);

public:
	QImage* screen;
	QDirectPainter* painter;
	QTimer* timer;
	QLabel* frameskip_lbl;
	
	bool sound;
	int rate;
	bool drawenabled;
	int gametype;
	int frameskip;
	bool rotated;

	uint32 JS;

public slots:
	void reset();
	void quit();
	void sound_tgl(bool);
	void frameskip_inc();
	void frameskip_dec();
	void openselector();
	void enabledraw();
	void disabledraw();
	void change_rate();
	void rotate(bool);

private:
	void updateStatusLine();
};

